package org.apache.commons.lang3;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.Iterator;
import java.util.NoSuchElementException;
import org.apache.commons.lang3.CharRange;

class CharacterIterator implements Iterator<Character> {
  private char current;
  
  private final CharRange range;
  
  private boolean hasNext;
  
  private CharacterIterator(CharRange r) {
    this.range = r;
    this.hasNext = true;
    if (CharRange.access$100(this.range)) {
      if (CharRange.access$200(this.range) == '\000') {
        if (CharRange.access$300(this.range) == Character.MAX_VALUE) {
          this.hasNext = false;
        } else {
          this.current = (char)(CharRange.access$300(this.range) + 1);
        } 
      } else {
        this.current = Character.MIN_VALUE;
      } 
    } else {
      this.current = CharRange.access$200(this.range);
    } 
  }
  
  private void prepareNext() {
    if (CharRange.access$100(this.range)) {
      if (this.current == Character.MAX_VALUE) {
        this.hasNext = false;
      } else if (this.current + 1 == CharRange.access$200(this.range)) {
        if (CharRange.access$300(this.range) == Character.MAX_VALUE) {
          this.hasNext = false;
        } else {
          this.current = (char)(CharRange.access$300(this.range) + 1);
        } 
      } else {
        this.current = (char)(this.current + 1);
      } 
    } else if (this.current < CharRange.access$300(this.range)) {
      this.current = (char)(this.current + 1);
    } else {
      this.hasNext = false;
    } 
  }
  
  public boolean hasNext() {
    return this.hasNext;
  }
  
  public Character next() {
    if (!this.hasNext)
      throw new NoSuchElementException(); 
    char cur = this.current;
    prepareNext();
    return Character.valueOf(cur);
  }
  
  public void remove() {
    throw new UnsupportedOperationException();
  }
}
